library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity mux_controller is
  
  port (
    clk        : in  std_logic;
    reset_n    : in  std_logic;
    read       : in  std_logic;
    write      : in  std_logic;
    chipselect : in  std_logic;
    address    : in  std_logic_vector(4 downto 0);
    readdata   : out std_logic_vector(15 downto 0);
    writedata  : in  std_logic_vector(15 downto 0);
	 outp			: out std_logic_vector(15 downto 0)
    );
  
end mux_controller;

architecture rtl of mux_controller is

  signal sel : std_logic_vector(15 downto 0);

begin

  process (clk)
  begin
    if rising_edge(clk) then
	   outp <= sel;
      if reset_n = '0' then
        readdata <= (others => '0');
      else
        if chipselect = '1' then
            if read = '1' then
              readdata <= sel;
            elsif write = '1' then
              sel <= writedata;
            end if;
        end if;
      end if;
    end if;
  end process;

end rtl;
