library ieee;
use ieee.std_logic_1164.all;

entity mux_hw_sw is
  
  port (
    clk        : in  std_logic;
    reset_n    : in  std_logic;
    signal inp		   : in  std_logic_vector(15 downto 0);
    signal chipselect : in std_logic;
    signal write, read : in std_logic;
    signal address  :  in std_logic_vector(17 downto 0);
    signal readdata : out std_logic_vector(15 downto 0);
    signal writedata : in std_logic_vector(15 downto 0);
    signal byteenable : in std_logic_vector(1 downto 0);
	 
    signal write_inp, read_inp : in std_logic;
	 signal writedata_inp : in std_logic_vector(15 downto 0);
	 signal address_inp  :  in std_logic_vector(17 downto 0);
	 
    signal SRAM_DQ : inout std_logic_vector(15 downto 0);
    signal SRAM_ADDR : out std_logic_vector(17 downto 0);
    signal SRAM_UB_N, SRAM_LB_N : out std_logic;
    signal SRAM_WE_N, SRAM_CE_N : out std_logic;
    signal SRAM_OE_N            : out std_logic;
	 outp : out std_logic
    );
  
end mux_hw_sw;

architecture dp of mux_hw_sw is
begin

mux: process(inp, chipselect, write, read, address, writedata, byteenable, write_inp, read_inp, writedata_inp, address_inp)			
begin			
			if inp = "0000000000001100" then
			   if write_inp = '1' then
				SRAM_DQ <= writedata; 
				else
            SRAM_DQ <= (others => 'Z');
				end if;
				readdata <= SRAM_DQ;
				SRAM_ADDR <= address_inp;
				SRAM_UB_N <= '0';
				SRAM_LB_N <= '0';
				SRAM_WE_N <= not write_inp;
				SRAM_CE_N <= '0';
				SRAM_OE_N <= not read_inp;
				outp <= '1';
	 
			else 
			   if write = '1' then
				SRAM_DQ <= writedata; 
				else
            SRAM_DQ <= (others => 'Z'); 
				end if;
				readdata <= (others => '0'); 
				SRAM_ADDR <= address;
				SRAM_UB_N <= not byteenable(1);
				SRAM_LB_N <= not byteenable(0);
				SRAM_WE_N <= not write;
				SRAM_CE_N <= not chipselect;
				SRAM_OE_N <= not read;
				outp <= '0';
			end if;
end process;
end dp;