library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity sprite_controller is
port(
   clk        : in  std_logic;
   reset_n    : in  std_logic;
	address   : in std_logic_vector(15 downto 0);-- higher 6 bit is sprite index, lower 6 bit is ROM number
	writedata : in std_logic_vector(31 downto 0);-- higher 10 bit is y value, lower 10 bit is x value
	write     : in std_logic;
	irq_out	 : out std_logic;
	 
	address_out   : out std_logic_vector(15 downto 0);-- higher 6 bit is sprite index, lower 6 bit is ROM number
	writedata_out : out std_logic_vector(31 downto 0);-- higher 10 bit is y value, lower 10 bit is x value
	write_out     : out std_logic;
	irq		     : in std_logic
	);
end sprite_controller;

architecture datapath of sprite_controller is
begin
	address_out 	<= address;
	writedata_out 	<= writedata;
	write_out 		<= write;
	irq_out 			<= irq;
end datapath;
