library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity timer is port (
  clk, reset_n, chipselect, read, write, address : in std_logic;
  readdata  : out std_logic_vector(15 downto 0);
  writedata : in  std_logic_vector(15 downto 0);
  irq       : out std_logic);
end timer;

architecture rtl of timer is 
  signal data    : std_logic_vector(15 downto 0);
  signal counter : unsigned(19 downto 0);
begin
  
  process (clk)
  begin
    if rising_edge(clk) then
      if reset_n = '0' then
        data <= (others => '0');
      else
        if chipselect = '1' then
          if address = '1' then
            if write = '1' then
              data <= writedata;
            elsif read = '1' then
              readdata <= data;
            end if;
          end if;
        end if;
      end if;
    end if;
  end process;
  
  process (clk)
  begin
    if rising_edge(clk) then
      if reset_n = '0' then
			counter <= (others => '0');
		else
			--if counter = "1111110000000000000000" then
			--	counter <= (others => '0');
			--else
				counter <= counter +1 ;
			--end if;
		end if;
    end if;
  end process;
    
  process (clk)
  begin
    if rising_edge(clk) then
      if reset_n = '0' then
        irq <= '0';
      else
        if counter = 1 then
          irq <= '1';
        elsif write = '1' and chipselect = '1' then
          irq <= '0'; 
        end if;
      end if;
    end if;
  end process;
  
end rtl;


